#ifndef POINT_H
#define POINT_H

#include <math.h>
#include "KeyValue.h"

class Point {
  public:
  double x, y; // The x and y coords

  double distance(Point &p1) {
    double dx = x - p1.x;
    double dy = y - p1.y;
    return sqrt(dx*dx+dy*dy);
  }
  static double distance(Point &p1, Point &p2) {
    return p1.distance(p2);
  }
  
  bool equals(Point &p1) {
    return ((x == p1.x) && (y == p1.y));
  } // End equals()

  void copyFrom(Point &p1) { x = p1.x; y = p1.y; }
  
  Point() { x = y = 0; }
  // Construct by reading key-value string "x=xval,y=yval"
  // Looks for x=xval, X=xval, y=yval, Y=yval, ignores everything else
  // Silently set x=0 (or y=0) if x=xval (or y=yval) not found
  Point(const char *kv_str) { x = y = 0; parse_kv_str(kv_str); }

  // Parse by reading key-value string "x=xval,y=yval"
  // Looks for x=xval, X=xval, y=yval, Y=yval, ignores everything else
  void parse_kv_str(const char *kv_str);
}; // End class Point
typedef class Point Point_t;

#endif
