#ifndef WP2P_PHY_H
#define WP2P_PHY_H

#include <packet.h>
#include <connector.h>

class WP2P_LL;

/** This class is similar to delay.cc.  I added this so that this can
    serve as a hook for (a) introducing wireless errors, as of now,
    and (b) later in future we can replace this with sophisticated PHY
    propagation models. */
class WP2P_PHY : public Connector {

public:
  WP2P_PHY();
  virtual void recv(Packet* p, Handler*);
  virtual double delay() { return delay_; }
  inline virtual double txtime(Packet* p) {
    return (8.0 * hdr_cmn::access(p)->size() / bandwidth_);
  }
  virtual double bandwidth() const { return bandwidth_; }

  /** TCL command interface */
  virtual int command(int argc, const char*const* argv);

protected:
  double bandwidth_; /* bandwidth of underlying link (bits/sec) */
  double delay_; /* line latency */

  /** A pointer to the LL object at the same node */
  WP2P_LL *ll_;

  long count;
}; // End class WP2P_PHY


#endif
